# Read the binary data from the file
$binaryData = Get-Content -Path "INPUT .DAT DIRECTORY" -Encoding Byte -Raw

# Initialize an empty string to store the result
$result = ""

# Iterate through each byte in the binary data
foreach ($byte in $binaryData) {
    # Check if the byte represents a printable ASCII character
    if ($byte -ge 32 -and $byte -le 126) {
        $result += [char]$byte
    } else {
        # Handle control characters or non-printable characters
        $result += "[$byte]"
    }
}

# Specify the path for the output text file
$outputFilePath = "OUTPUT .TXT DIRECTORY"

# Write the result to a text file
$result | Out-File -FilePath $outputFilePath -Encoding UTF8

# Display a message indicating the process is complete
Write-Output "Translation complete. Results written to: $outputFilePath"